
// sampleDlg.h :  
//

#pragma once
#include "afxwin.h"
#include <iostream>
#include <list>

#include "ToastLoggerManager.h"

using namespace std;


// CsampleDlg ȭ 
class CsampleDlg : public CDialogEx
{
// Դϴ.
public:
	CsampleDlg(CWnd* pParent = NULL);	// ǥ Դϴ.

// ȭ  Դϴ.
	enum { IDD = IDD_SAMPLE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV Դϴ.

// Դϴ.
protected:
	HICON m_hIcon;

	//  ޽  Լ
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBnClickedButInit();
	afx_msg void OnBnClickedStress();
	afx_msg void OnCbnSelchangeServiceZone();

public:
	afx_msg void GetEditString(int nID, CString &str);
	afx_msg const char* ConvertMessage(CString str);
	
protected:
	UINT WorkerThreadProc(int sendCount);
public:
	static UINT WorkerThreadProcStatic( LPVOID Param );

private:
	CComboBox m_crashModeList;
	CComboBox m_serviceZoneList;	
	CComboBox m_CrashEnable;

	CListBox m_userCustomFields;
	CListBox m_globalCustomFields;

private:
	CString m_appkey;
	CString m_version;
	CString m_logType;
	CString m_logSource;
	CString m_message;
	CString m_crashModel;
	CString m_serviceZone;
	CString m_dialogMessage;
	CString m_threadCountString;
	CString m_stressSendCountString;
	CString crashMessage;
	CString strGdpr;
	CString crashEnable;

	TOAST_LANGUAGE_TYPE languageType;
	TOAST_SERVICE_ZONE serviceZone;
	bool enableCrashSilenceMode;
	bool enableApplyGDPR;
	bool enableCrashReporter;

private:
	int m_threadCount;
	int m_stressSendCount;

private:
	CString m_globalCustomFieldKey;
	CString m_globalCustomFieldValue;
	CString m_userCustomFieldKey;
	CString m_userCustomFieldValue;

private:
	CString m_sendCount;

public:	
	afx_msg void OnBnClickedInfo();
	afx_msg void OnBnClickedWarn();
	afx_msg void OnBnClickedDebug();
	afx_msg void OnBnClickedError();
	afx_msg void OnBnClickedFatal();
	afx_msg void OnBnClickedCrash();
	afx_msg void OnBnClickedAddGlobalCustom();
	afx_msg void OnBnClickedAddUserCustom();
	afx_msg void OnEnChangeSendCount();
	afx_msg void OnBnClickedStressTest();
	afx_msg void OnEnChangeThreadCount();
	afx_msg void OnEnChangeStressSendCount();
	afx_msg void OnBnClickedDeleteGlobalCustom();
	afx_msg void OnBnClickedDeleteUserField();
	afx_msg void OnBnClickedClearGlobalCustom();
	afx_msg void OnBnClickedClearUserField();
	afx_msg void OnBnClickedApplyDialogText();
	afx_msg void OnCbnSelchangeCrashMode();
	afx_msg void OnEnChangeDialogText();

private:
	CComboBox m_LanguageList;
	CComboBox m_GdprFilterList;
	list<CString> m_globalKeyList;

	virtual BOOL PreTranslateMessage(MSG* pMsg);
};
